//+------------------------------------------------------------------+
//|                                                     iMA_corr.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


//+------------------------------------------------------------------+
//| extern input parameters                                          |
//+------------------------------------------------------------------+

extern int Slippage=5;
extern int LotDiff=400000;
extern double ProfitDiff=0.0005;
extern int MagicNumber_101=101000;
extern int MagicNumber_102=102000;

double dXPoint=1;
//==============================================================================================================	
int init()
  {
//----
if (Digits==3||Digits==5)
{
dXPoint=10;
}

if (Digits==3||Digits==5)
{
dXPoint=10;
int SLIPPAGE=SLIPPAGE*dXPoint;
} 
//----
   return(0);
  }
//==============================================================================================================	
int deinit()
  {
//----
   
//----
   return(0);
  }
//==============================================================================================================	
int start()
  {
  double LotEURUSD=0.01;
  double LotGBPUSD=0.01;
  //------------------------------------------------------
  //Calculate lot digits
  double LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
  int LotDigit;
  if(LotStep==1) LotDigit=0;
  if(LotStep==0.1) LotDigit=1;
  if(LotStep==0.01) LotDigit=2;
  LotEURUSD=NormalizeDouble(AccountBalance()/LotDiff,LotDigit);
  LotGBPUSD=NormalizeDouble(AccountBalance()/LotDiff,LotDigit);
  //------------------------------------------------------
   startLookingForProfits(MagicNumber_101);
   startLookingForProfits(MagicNumber_102);
  //------------------------------------------------------
   int eurusdCount101 = countOpenedOrders(MagicNumber_101,"EURUSD");
   int gbpusdCount101 = countOpenedOrders(MagicNumber_101,"GBPUSD");
   int eurusdCount102 = countOpenedOrders(MagicNumber_102,"EURUSD");
   int gbpusdCount102 = countOpenedOrders(MagicNumber_102,"GBPUSD");
  //------------------------------------------------------
   if ((iMA("EURUSD",0,7,1,MODE_SMA,PRICE_CLOSE,0)>iMA("EURUSD",0,14,1,MODE_SMA,PRICE_CLOSE,0)) && (iMA("GBPUSD",0,7,1,MODE_SMA,PRICE_CLOSE,0)<iMA("GBPUSD",0,14,1,MODE_SMA,PRICE_CLOSE,0)))
   {
   if (eurusdCount101==0) OrderSend("EURUSD",OP_SELL,LotEURUSD,MarketInfo("EURUSD",MODE_BID),2,0,0,"Magic Number 101000",MagicNumber_101,0,CLR_NONE);
   Sleep(1000);
   if (gbpusdCount101==0) OrderSend("GBPUSD",OP_BUY,LotGBPUSD,MarketInfo("GBPUSD",MODE_ASK),2,0,0,"Magic Number 101000",MagicNumber_101,0,CLR_NONE);
   Sleep(1000);   
   }        
  //------------------------------------------------------
   RefreshRates();
  //------------------------------------------------------
   if ((iMA("EURUSD",0,7,1,MODE_SMA,PRICE_CLOSE,0)<iMA("EURUSD",0,14,1,MODE_SMA,PRICE_CLOSE,0)) && (iMA("GBPUSD",0,7,1,MODE_SMA,PRICE_CLOSE,0)>iMA("GBPUSD",0,14,1,MODE_SMA,PRICE_CLOSE,0)))
   {
   if (eurusdCount102==0) OrderSend("EURUSD",OP_BUY,LotEURUSD,MarketInfo("EURUSD",MODE_ASK),2,0,0,"Magic Number 102000",MagicNumber_102,0,CLR_NONE);
   Sleep(1000);
   if (gbpusdCount102==0) OrderSend("GBPUSD",OP_SELL,LotGBPUSD,MarketInfo("GBPUSD",MODE_BID),2,0,0,"Magic Number 102000",MagicNumber_102,0,CLR_NONE);
   Sleep(1000);
   }
  //------------------------------------------------------
   return(0);   
   }
//==============================================================================================================	
int countOpenedOrders(int magicNumber, string symbol)
{
   int openedOrders=0;   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != magicNumber) continue;
      if(OrderSymbol()      != symbol)      continue;
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) openedOrders++;
   }      
   return(openedOrders);
}
//==============================================================================================================	
int startLookingForProfits(int MagicNumber)
  {
   int ProfitTarget=AccountBalance()*ProfitDiff;
   double dblProfit=0;
   int POS=0;
   bool boolTerm=false;
   while(boolTerm==false)
     {
      if(OrderSelect(POS,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==MagicNumber) dblProfit=dblProfit+OrderProfit();
         POS++;
        }
      else
         boolTerm=true;
     }
   if(dblProfit>=ProfitTarget)
     {
      for(int i=OrdersTotal()-1;i>=0;i--)
        {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderMagicNumber()==MagicNumber)
           {
            int type=OrderType();
            bool result=false;

            switch(type)
              {
               //Close opened long positions
               case OP_BUY  : 
                  result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Red);
               break;

               //Close opened short positions
               case OP_SELL : 
                  result=OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,LimeGreen);
               break;
              }

            if(result==false)
              {
               Sleep(1000);
              }
           }
        }
      Print("Profit Target For MagicNumber based Trades Reached & They have been Closed");
      return(0);
     }
   return(0);
  }
  //==============================================================================================================	

